/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	kumoriv1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeV3Deployments implements V3DeploymentInterface
type FakeV3Deployments struct {
	Fake *FakeKumoriV1
	ns   string
}

var v3deploymentsResource = schema.GroupVersionResource{Group: "kumori.systems", Version: "v1", Resource: "v3deployments"}

var v3deploymentsKind = schema.GroupVersionKind{Group: "kumori.systems", Version: "v1", Kind: "V3Deployment"}

// Get takes name of the v3Deployment, and returns the corresponding v3Deployment object, and an error if there is any.
func (c *FakeV3Deployments) Get(name string, options v1.GetOptions) (result *kumoriv1.V3Deployment, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(v3deploymentsResource, c.ns, name), &kumoriv1.V3Deployment{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.V3Deployment), err
}

// List takes label and field selectors, and returns the list of V3Deployments that match those selectors.
func (c *FakeV3Deployments) List(opts v1.ListOptions) (result *kumoriv1.V3DeploymentList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(v3deploymentsResource, v3deploymentsKind, c.ns, opts), &kumoriv1.V3DeploymentList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &kumoriv1.V3DeploymentList{ListMeta: obj.(*kumoriv1.V3DeploymentList).ListMeta}
	for _, item := range obj.(*kumoriv1.V3DeploymentList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested v3Deployments.
func (c *FakeV3Deployments) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(v3deploymentsResource, c.ns, opts))

}

// Create takes the representation of a v3Deployment and creates it.  Returns the server's representation of the v3Deployment, and an error, if there is any.
func (c *FakeV3Deployments) Create(v3Deployment *kumoriv1.V3Deployment) (result *kumoriv1.V3Deployment, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(v3deploymentsResource, c.ns, v3Deployment), &kumoriv1.V3Deployment{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.V3Deployment), err
}

// Update takes the representation of a v3Deployment and updates it. Returns the server's representation of the v3Deployment, and an error, if there is any.
func (c *FakeV3Deployments) Update(v3Deployment *kumoriv1.V3Deployment) (result *kumoriv1.V3Deployment, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(v3deploymentsResource, c.ns, v3Deployment), &kumoriv1.V3Deployment{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.V3Deployment), err
}

// Delete takes name of the v3Deployment and deletes it. Returns an error if one occurs.
func (c *FakeV3Deployments) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(v3deploymentsResource, c.ns, name), &kumoriv1.V3Deployment{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeV3Deployments) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(v3deploymentsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &kumoriv1.V3DeploymentList{})
	return err
}

// Patch applies the patch and returns the patched v3Deployment.
func (c *FakeV3Deployments) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *kumoriv1.V3Deployment, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(v3deploymentsResource, c.ns, name, pt, data, subresources...), &kumoriv1.V3Deployment{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.V3Deployment), err
}
